'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports['default'] = create;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _wrapper = require('./wrapper');

var _object = require('./object');

/**
 * @param {Function} Thenable
 * @returns {ThenChrome}
 */

function create(Thenable) {
    return Object.keys(_config2['default']).reduce(function (result, namespace) {
        createNamespace(result, namespace);
        return wrapMethods(result, namespace, _config2['default'][namespace], Thenable);
    }, {});
}

/**
 * Create namespace
 * @param {Object} obj
 * @param {String} namespace
 * @returns {*}
 */
function createNamespace(obj, namespace) {
    var chromeNamespace = (0, _object.get)(obj, namespace);
    if (!chromeNamespace) {
        (0, _object.set)(obj, namespace);
    }
    return obj;
}

/**
 * @param {Object} obj
 * @param {String} namespace
 * @param {Object} data
 * @param {Array<String>} data.async
 * @param {Array<String>} data.sync
 * @param {Function} Promise constructor
 * @returns {Object}
 */
function wrapMethods(obj, namespace, data, Promise) {
    (0, _wrapper.wrapAsyncMethods)(obj, namespace, data.async, Promise);
    (0, _wrapper.wrapSyncMethods)(obj, namespace, data.sync, Promise);
    return obj;
}
module.exports = exports['default'];