'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _api = require('./api');

var _api2 = _interopRequireDefault(_api);

var Thenable = getNativePromise();

/**
 * Get native promise constructor
 * @returns {*}
 */
function getNativePromise() {
    if (typeof window !== 'undefined' && window.Promise) {
        return window.Promise;
    }
    if (typeof global !== 'undefined' && global.Promise) {
        return global.Promise;
    }
}

if (!Thenable) {
    throw new TypeError('Native promise does not support in your environment. Use /out/api function directly');
}

/**
 * @type {ThenChrome}
 */
exports['default'] = (0, _api2['default'])(Thenable);
module.exports = exports['default'];